<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for FilenameComparator.
 * Generated by PHPUnit on 2012-07-03 at 17:39:47.
 * @group directory_iterators
 */
class FilenameComparatorTest extends \PHPUnit_Framework_TestCase {

    /** @var FilenameComparator */
    private $comparator;

    protected function setUp() {
        $this->comparator = new FilenameComparator();
    }

    public function testBasicCompare() {
        $elementA = $this->getElement('aaaaa');
        $elementB = $this->getElement('bbbbb');
        parent::assertEquals($this->comparator->compare($elementA, $elementA), 0);
        parent::assertEquals($this->comparator->compare($elementB, $elementB), 0);
        parent::assertEquals($this->comparator->compare($elementB, $elementA), 1);
        parent::assertEquals($this->comparator->compare($elementA, $elementB), -1);
    }

    public function testCaseSensitiveCompare() {
        $this->comparator->setCaseSensitive(true);
        $elementUpperA = $this->getElement('AAAAA');
        $elementLowerA = $this->getElement('aaaaa');
        parent::assertEquals($this->comparator->compare($elementUpperA, $elementUpperA), 0);
        parent::assertEquals($this->comparator->compare($elementLowerA, $elementLowerA), 0);
        parent::assertEquals($this->comparator->compare($elementLowerA, $elementUpperA), 1);
        parent::assertEquals($this->comparator->compare($elementUpperA, $elementLowerA), -1);
    }

    public function testUTF8Compare() {
        $this->comparator->setUTF8(true);
        parent::markTestSkipped('Only on Linux. Localization must be set for strcoll');
    }
  
    /** return Treewec\DirectoryIterators\IteratorElement */
    private function getElement($name) {
        return new IteratorElement(0, new \SplFileInfo(TREEWEC_VIEW_DIR . $name));
    }

}

?>